/*
     */
#include "regclass.h"
#include "commclass.h"
#include "xvmconfig.h"
//#include "xvmsupport.h"

// not now needed
//
//#include "execclass.h"

#ifndef _XVM_H
#define _XVM_H

#define XVM_STOPED 0
#define XVM_EXECUTING 1
#define XVM_STEPMODE 2
#define XVM_USERBREAK -2
#define XVM_ERRORSTOP -3

#define XVM_ERRT_NOERR 0
#define XVM_ERRT_UNKNOWERR 1
#define XVM_ERRT_UNKNOWNCOMM 2
#define XVM_ERRT_PARSEERR 3
#define XVM_ERRT_OUTOFRANGE 4
#define XVM_ERRT_INSUFFARGS 5
#define XVM_ERRT_OTHERERR 6

#define XVM_ERRM_NOERR "All OK."
#define XVM_ERRM_UNKNOWNERR "Unknown error"
#define XVM_ERRM_UNKNOWNCOMM "Unknown statement"
#define XVM_ERRM_PARSEERR "Parse error"
#define XVM_ERRM_OUTOFRANGE "Out of range"
#define XVM_ERRM_INSUFFARGS "Insufficient arguments"
#define XVM_ERRM_OTHERERR "Error"

#define XVM_REGM_CHAR 1
#define XVM_REGM_DIG 2

#define XVM_CASH 1
#define XVM_NOCASH 0

#define XVM_STATT_Z 1
#define XVM_STATT_S 2
#define XVM_STATT_T 3
#define XVM_STATT_J 4
#define XVM_STATT_STOP 0
#define XVM_STATT_ERR -1

#define XVM_STAT_Z 'Z'
#define XVM_STAT_S 'S'
#define XVM_STAT_T 'T'
#define XVM_STAT_J 'J'
#define XVM_STAT_STOP '\0'

#ifndef TRUE

#define TRUE 1
#define FALSE 0

#endif //TRUE&FALSE

struct xvmregcash{
    //int no;
    long reg;
    bool busy;
    int acces;
};

struct xvmcommcash{
    //int no;
    int type;
    int arg1;
    int arg2;
    int arg3;
    bool busy;
    int acces;
};

class Xvm{
public:
  
  Xvm(int regs,int comms);
  Xvm();
  ~Xvm();
  
  int InitVM(int regs,int comms); 
  int InitProg(int comm);
  int InitProg(int comm,int mod);
  
  int SetReg(int reg ,char* val);
  void SetDReg(register int reg,register long val);
  void SetNCDReg(register int reg,register long val);
  char* GetReg(int reg);
  long GetDReg(register int reg);
  
  int SetComm(int comm,char* stat);
  char* GetComm(int comm){return CommList->GetVal(comm);};
  
  int SetComment(int comm,char* comment);
  char* GetComment(int comm);
  
  int GetProgStatus(){return ProgStatus;};
  int GetCurCommNo();
  int GetPrevCommNo();
  int GetErrorType();
  char* GetError();
  
  void StepProg();
  int StopProg(int err);
  
  char* GetVersion();
  char* GetAbout();
  
  int GetCommListLen(){return CommListLen;};
  int GetRegListLen(){return RegListLen;};
  
  int SetOptions(int opt);
  int GetOptions();
  int SyncRegs();
  
  //char& operator +(char& rightv);
  
private:
  
  RegListClass *RegList;//=0;
  int RegListLen;
  CommListClass *CommList;//=0;
  int CommListLen;
  
  //ExecutorClass *Executor;
  
  int SetProgStatus(int status);
  inline void SetCurCommNo(int no);
  inline void SetPrevCommNo(int no);
  
  int CurCommNo;//=1;
  int PrevCommNo;
  char* CurComm;//="";
  int ProgStatus;//=-1;
  char* Error;//="Uninitialised";
  int ErrorType;//=-1;
  char* Args[3];//=(0,0,0);
  int DArg1;
  int DArg2;
  int DArg3;
  
  //  from "execclass.h"
	
  void DetermComm();
  void ExtractArgs(char* comm);
  void ResolvArgs(char* args[3]);
  void DExtractArgs();
  void DResolvArgs();
  int ProcessComm(char* args[3]);
  void DProcessComm();
  void Init();
  void VerifyComm();
  int Jump;
  void SortCash();
  int acces;
  int sorted;
  int commcashhead[MAX_XVM_CASHCOMM];
  int *commhead;
  int regcashhead[MAX_XVM_CASHREG];
  int *reghead;
  
  int type;
  int RegMode;
  xvmcommcash CashComm[MAX_XVM_CASHCOMM];
  xvmregcash CashReg[MAX_XVM_CASHREG];
  bool CashMode;
  int LastCash;
  int LastRegCashh;
  int PrevRegCash;
  
  int ExZeroReg(int reg);
  inline void ExDZeroReg(int reg);
  int ExIncReg(int reg);
  inline void ExDIncReg(int reg);
  int ExMovReg(int src,int tgt);
  inline void ExDMovReg(int src,int tgt);
  int ExJump(int arg1,int arg2,int to);
  inline void ExDJump(int arg1,int arg2,int to);

  // end (from...)
  
};
#endif //_XVM_H

//#ifndef _OPERATOR_PLUS
//#define _OPERATOR_PLUS
//char& operator + (char& leftv,char& rightv){
//	return strcat(leftv,rightv);
//};
//#endif //_OPERATOR_PLUS

